//+------------------------------------------------------------------+
//|                                                          PSI.mq4 |
//|                                                           doshur |
//|                                            http://www.doshur.com |
//+------------------------------------------------------------------+
#property copyright "doshur"
#property link      "http://www.doshur.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 White
#property indicator_color2 Red

extern int First = 8;
extern int Second = 13;
extern int SignalPeriod = 5;

//---- buffers
double PSI[];
double Signal[];
double First_Buffer[];
double Second_Buffer[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(4);

   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, PSI);

   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, Signal);

   SetIndexBuffer(2, First_Buffer);
   SetIndexBuffer(3, Second_Buffer);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit, i;
   int counted_bars = IndicatorCounted();

   double CurrPP, PrevPP;

   limit = Bars - counted_bars;
//----
   for(i = 0; i <= limit; i++)
   {
      CurrPP = (High[i] + Low[i] + Close[i]) / 3;
      PrevPP = (High[i + 1] + Low[i + 1] + Close[i + 1]) / 3;

      First_Buffer[i] = CurrPP - PrevPP;
   }

   for(i = 0; i <= limit; i++)
   {
      Second_Buffer[i] = iMAOnArray(First_Buffer, 0, First, 0, MODE_EMA, i);
   }

   for(i = 0; i <= limit; i++)
   {
      PSI[i] = (iMAOnArray(Second_Buffer, 0, Second, 0, MODE_EMA, i) + PSI[i - 1] + PSI[i - 2]) / 3;
   }

   for(i = 0; i <= limit; i++)
   {
      Signal[i] = iMAOnArray(PSI, 0, SignalPeriod, 0, MODE_SMA, i);
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+